#!/bin/sh
image_dir="$1"
# the image directories are located in $ocsroot
ocsroot="/home/partimag"
drblroot="/tftpboot/nodes/"
# the time (hourse) to stop ocs, i.e. we estimate the time when the partimage
# restore the disk image will be about $time_to_stop_ocs hours.
time_to_stop_ocs="3"

# Check if root or not
if [ ! "$UID" = "0" ]; then
  echo
  echo "[$LOGNAME] You need to run this script \"$0\" as root."
  echo
  exit 1
fi

if [ $# -ne 1 ]; then 
  echo "XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX"
  echo "You must provide the image directory to restore!!!"
  echo "Usage: $0 partimage_saved_dir"
  echo "Example: $0 woody_base" 
  exit 1
fi
if [ ! -d "$ocsroot/$image_dir" ]; then
  echo "XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX"
  echo "The file \"$image_dir\" can NOT be found in direcotry $ocsroot!!!"
  echo "We can not go on!!!"
  echo "Program terminated!!!"
  exit 1
fi

# Switch the clients' mode to drbl
/opt/drbl/sbin/drbl-client-switch -l 0 remote-linux

# set the image file to restore
/opt/drbl/sbin/drbl-ocs -l 0 startdisk restore $ocsroot/$image_dir

# reboot or boot all the clients to let client to restore OS...
# first, for M$ windows clients, maybe 
# Note! You must already have ssh key in your clients for M$ Windows, 
# to make it, you'd better to install cygwin and setup the sshd service
# in clients.
/opt/drbl/bin/drbl-doit -u administrator /usr/bin/reboot -f now &
# 2nd, for DRBL clients, maybe
/opt/drbl/bin/drbl-doit -u root /sbin/reboot &
# 3rd, if the clients are warm shutdown, it can be awaken by wake on LAN
/opt/drbl/bin/drbl-doit --wol &

# When clients finish restoration, maybe 3 hours later
echo "/opt/drbl/sbin/drbl-ocs -l 0 stop" | at now + $time_to_stop_ocs hours
echo "/opt/drbl/sbin/drbl-client-switch -l 0 local" | at now + $time_to_stop_ocs hours
